Package net.sf.saxon.tree.wrapper

## Class AbstractNodeWrapper

- java.lang.Object
- - net.sf.saxon.tree.wrapper.AbstractNodeWrapper

- All Implemented Interfaces:
    `javax.xml.transform.Source`, `javax.xml.transform.SourceLocator`, `GroundedValue`, `Item`, `NodeInfo`, `Sequence`, `Location`, `VirtualNode`, `org.xml.sax.Locator`
  Direct Known Subclasses:
    `AxiomLeafNodeWrapper`, `AxiomParentNodeWrapper`, `DOM4JNodeWrapper`, `DOMNodeWrapper`, `JDOM2NodeWrapper`, `XOMNodeWrapper`

      public abstract class AbstractNodeWrapper
      extends java.lang.Object
      implements NodeInfo, VirtualNode

  A node in the XML parse tree representing an XML element, character content, or attribute.

  This implementation of the NodeInfo interface contains common code used by many "wrapper" implementations for external data models.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected TreeInfo` | `treeInfo` |

    - ### Fields inherited from interface net.sf.saxon.om.NodeInfo

      `IS_DTD_TYPE, IS_NILLED`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AbstractNodeWrapper()` |

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `AtomicSequence` | `atomize()` | Get the typed value.
    `boolean` | `equals​(java.lang.Object other)` | The equals() method compares nodes for identity.
    `NamespaceMap` | `getAllNamespaces()` | Get all the namespace bindings that are in-scope for this element.
    `java.lang.String` | `getAttributeValue​(java.lang.String uri, java.lang.String local)` | Get the string value of a given attribute of this node.
    `java.lang.String` | `getBaseURI()` | Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node.
    `int` | `getColumnNumber()` | Get column number
    `NamespaceBinding[]` | `getDeclaredNamespaces​(NamespaceBinding[] buffer)` | Get all namespace declarations and undeclarations defined on this element.
    `java.lang.String` | `getDisplayName()` | Get the display name of this node.
    `int` | `getFingerprint()` | Get the fingerprint of the node
    `int` | `getLineNumber()` | Get line number
    `NamePool` | `getNamePool()` | Get the name pool for this node
    `java.lang.Object` | `getRealNode()` | Get the node underlying this virtual node.
    `NodeInfo` | `getRoot()` | Get the root node - always a document node with this tree implementation
    `java.lang.String` | `getStringValue()` | Return the string value of the node.
    `java.lang.String` | `getSystemId()` | Get the System ID for the node.
    `TreeInfo` | `getTreeInfo()` | Get information about the tree to which this NodeInfo belongs
    `boolean` | `hasChildNodes()` | Determine whether the node has any children.
    `boolean` | `hasFingerprint()` | Test whether a fingerprint is available for the node name
    `int` | `hashCode()` | The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
    `protected abstract AxisIterator` | `iterateAttributes​(java.util.function.Predicate<? super NodeInfo> nodeTest)` | Return an iterator over the attributes of this element node.
    `AxisIterator` | `iterateAxis​(int axisNumber)` | Return an iteration over the nodes reached by the given axis from this node
    `AxisIterator` | `iterateAxis​(int axisNumber, java.util.function.Predicate<? super NodeInfo> nodeTest)` | Return an iteration over the nodes reached by the given axis from this node.
    `protected abstract AxisIterator` | `iterateChildren​(java.util.function.Predicate<? super NodeInfo> nodeTest)` | Return an iterator over the children of this node.
    `protected AxisIterator` | `iterateDescendants​(java.util.function.Predicate<? super NodeInfo> nodeTest, boolean includeSelf)` | Return an iterator over the descendants of this node.
    `protected abstract AxisIterator` | `iterateSiblings​(java.util.function.Predicate<? super NodeInfo> nodeTest, boolean forwards)` | Return an iterator over the siblings of this node.
    `Location` | `saveLocation()` | Get an immutable copy of this Location object.
    `void` | `setSystemId​(java.lang.String uri)` | Set the system ID.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `asIterable, concatenate, containsNode, effectiveBooleanValue, materialize`

    - ### Methods inherited from interface net.sf.saxon.om.Item

      `getLength, getStringValueCS, head, itemAt, iterate, reduce, subsequence`

    - ### Methods inherited from interface net.sf.saxon.om.NodeInfo

      `attributes, children, children, compareOrder, copy, generateId, getConfiguration, getGenre, getLocalPart, getNodeKind, getParent, getPrefix, getPublicId, getSchemaType, getURI, isId, isIdref, isNilled, isSameNodeInfo, isStreamed, toShortString`

    - ### Methods inherited from interface net.sf.saxon.om.Sequence

      `makeRepeatable`

    - ### Methods inherited from interface javax.xml.transform.Source

      `isEmpty`

    - ### Methods inherited from interface net.sf.saxon.tree.wrapper.VirtualNode

      `getUnderlyingNode`

- - ### Field Detail

    - #### treeInfo

          protected TreeInfo treeInfo

  - ### Constructor Detail

    - #### AbstractNodeWrapper

          public AbstractNodeWrapper()

  - ### Method Detail

    - #### getTreeInfo

          public TreeInfo getTreeInfo()

      Description copied from interface: `NodeInfo`
      Get information about the tree to which this NodeInfo belongs
      Specified by:
        `getTreeInfo` in interface `NodeInfo`
      Returns:
        the TreeInfo

    - #### getRealNode

          public final java.lang.Object getRealNode()

      Get the node underlying this virtual node. If this is a VirtualNode the method will automatically drill down through several layers of wrapping.
      Specified by:
        `getRealNode` in interface `VirtualNode`
      Returns:
        The underlying node.

    - #### getNamePool

          public NamePool getNamePool()

      Get the name pool for this node
      Returns:
        the NamePool

    - #### atomize

          public AtomicSequence atomize()
                                 throws XPathException

      Get the typed value.
      Specified by:
        `atomize` in interface `Item`
      Specified by:
        `atomize` in interface `NodeInfo`
      Returns:
        the typed value. This will either be a single AtomicValue or a value whose items are atomic values.
      Throws:
        `XPathException` - if the node has no typed value, for example if it is an element node with element-only content
      Since:
        8.5 - signature changed in 9.5

    - #### equals

          public boolean equals​(java.lang.Object other)

      The equals() method compares nodes for identity. It is defined to give the same result as isSameNodeInfo().
      Specified by:
        `equals` in interface `NodeInfo`
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `other` - the node to be compared with this node
      Returns:
        true if this NodeInfo object and the supplied NodeInfo object represent the same node in the tree.
      Since:
        8.7 Previously, the effect of the equals() method was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics. It is safer to use isSameNodeInfo() for this reason. The equals() method has been defined because it is useful in contexts such as a Java Set or HashMap.

    - #### hashCode

          public int hashCode()

      The hashCode() method obeys the contract for hashCode(): that is, if two objects are equal (represent the same node) then they must have the same hashCode()
      Specified by:
        `hashCode` in interface `NodeInfo`
      Overrides:
        `hashCode` in class `java.lang.Object`
      Since:
        8.7 Previously, the effect of the equals() and hashCode() methods was not defined. Callers should therefore be aware that third party implementations of the NodeInfo interface may not implement the correct semantics.

    - #### getSystemId

          public java.lang.String getSystemId()

      Get the System ID for the node.
      Specified by:
        `getSystemId` in interface `Location`
      Specified by:
        `getSystemId` in interface `org.xml.sax.Locator`
      Specified by:
        `getSystemId` in interface `NodeInfo`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.Source`
      Specified by:
        `getSystemId` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the System Identifier of the entity in the source document containing the node, or null if not known. Note this is not the same as the base URI: the base URI can be modified by xml:base, but the system ID cannot.

    - #### setSystemId

          public void setSystemId​(java.lang.String uri)

      Set the system ID. Required because NodeInfo implements the JAXP Source interface
      Specified by:
        `setSystemId` in interface `javax.xml.transform.Source`
      Parameters:
        `uri` - the system ID.

    - #### getBaseURI

          public java.lang.String getBaseURI()

      Get the Base URI for the node, that is, the URI used for resolving a relative URI contained in the node.
      Specified by:
        `getBaseURI` in interface `NodeInfo`
      Returns:
        the base URI of the node, taking into account xml:base attributes if present

    - #### getLineNumber

          public int getLineNumber()

      Get line number
      Specified by:
        `getLineNumber` in interface `Location`
      Specified by:
        `getLineNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getLineNumber` in interface `NodeInfo`
      Specified by:
        `getLineNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the line number of the node in its original source document; or -1 if not available. Always returns -1 in this implementation.

    - #### getColumnNumber

          public int getColumnNumber()

      Get column number
      Specified by:
        `getColumnNumber` in interface `Location`
      Specified by:
        `getColumnNumber` in interface `org.xml.sax.Locator`
      Specified by:
        `getColumnNumber` in interface `NodeInfo`
      Specified by:
        `getColumnNumber` in interface `javax.xml.transform.SourceLocator`
      Returns:
        the column number of the node in its original source document; or -1 if not available

    - #### saveLocation

          public Location saveLocation()

      Get an immutable copy of this Location object. By default Location objects may be mutable, so they should not be saved for later use. The result of this operation holds the same location information, but in an immutable form.
      Specified by:
        `saveLocation` in interface `Location`
      Returns:
        an immutable copy (which may be the original object, if it is already immutable)

    - #### getStringValue

          public java.lang.String getStringValue()

      Return the string value of the node. The interpretation of this depends on the type of node. For an element it is the accumulated character content of the element, including descendant elements.
      Specified by:
        `getStringValue` in interface `GroundedValue`
      Specified by:
        `getStringValue` in interface `Item`
      Specified by:
        `getStringValue` in interface `NodeInfo`
      Returns:
        the string value of the node
      See Also:
        `Item.getStringValueCS()`

    - #### getDisplayName

          public java.lang.String getDisplayName()

      Get the display name of this node. For elements and attributes this is [prefix:]localname. For unnamed nodes, it is an empty string.
      Specified by:
        `getDisplayName` in interface `NodeInfo`
      Returns:
        The display name of this node. For a node with no name, return an empty string.

    - #### getAttributeValue

          public java.lang.String getAttributeValue​(java.lang.String uri,
                                                    java.lang.String local)

      Get the string value of a given attribute of this node.

      The default implementation is suitable for nodes other than elements.

      Specified by:
        `getAttributeValue` in interface `NodeInfo`
      Parameters:
        `uri` - the namespace URI of the attribute name. Supply the empty string for an attribute that is in no namespace
        `local` - the local part of the attribute name.
      Returns:
        the attribute value if it exists, or null if it does not exist. Always returns null if this node is not an element.
      Since:
        9.4

    - #### iterateAxis

          public AxisIterator iterateAxis​(int axisNumber)

      Return an iteration over the nodes reached by the given axis from this node
      Specified by:
        `iterateAxis` in interface `NodeInfo`
      Parameters:
        `axisNumber` - the axis to be used
      Returns:
        a SequenceIterator that scans the nodes reached by the axis in turn.
      See Also:
        `AxisInfo`

    - #### iterateAxis

          public AxisIterator iterateAxis​(int axisNumber,
                                          java.util.function.Predicate<? super NodeInfo> nodeTest)

      Return an iteration over the nodes reached by the given axis from this node.

      This superclass provides implementations of the ancestor, ancestor-or-self, following, namespace, parent, preceding, self, and preceding-or-ancestor axes. The other axes are implemented by calling methods iterateAttributes(), iterateChildren(), iterateDescendants(), and iterateSiblings(), which must be provided in a subclass.

      Specified by:
        `iterateAxis` in interface `NodeInfo`
      Parameters:
        `axisNumber` - the axis to be used
        `nodeTest` - A pattern to be matched by the returned nodes
      Returns:
        a SequenceIterator that scans the nodes reached by the axis in turn.
      See Also:
        `AxisInfo`

    - #### iterateAttributes

          protected abstract AxisIterator iterateAttributes​(java.util.function.Predicate<? super NodeInfo> nodeTest)

      Return an iterator over the attributes of this element node. This method is only called after checking that the node is an element.
      Parameters:
        `nodeTest` - a test that the returned attributes must satisfy
      Returns:
        an iterator over the attribute nodes. The order of the result, although arbitrary, must be consistent with document order.

    - #### iterateChildren

          protected abstract AxisIterator iterateChildren​(java.util.function.Predicate<? super NodeInfo> nodeTest)

      Return an iterator over the children of this node. This method is only called after checking that the node is an element or document.
      Parameters:
        `nodeTest` - a test that the returned attributes must satisfy
      Returns:
        an iterator over the child nodes, in document order.

    - #### iterateSiblings

          protected abstract AxisIterator iterateSiblings​(java.util.function.Predicate<? super NodeInfo> nodeTest,
                                                          boolean forwards)

      Return an iterator over the siblings of this node. This method is only called after checking that the node is an element, text, comment, or PI node.
      Parameters:
        `nodeTest` - a test that the returned siblings must satisfy
        `forwards` - true for following siblings, false for preceding siblings
      Returns:
        an iterator over the sibling nodes, in axis order.

    - #### iterateDescendants

          protected AxisIterator iterateDescendants​(java.util.function.Predicate<? super NodeInfo> nodeTest,
                                                    boolean includeSelf)

      Return an iterator over the descendants of this node. This method is only called after checking that the node is an element or document node.
      Parameters:
        `nodeTest` - a test that the returned descendants must satisfy
        `includeSelf` - true if this node is to be included in the result
      Returns:
        an iterator over the sibling nodes, in axis order.

    - #### getDeclaredNamespaces

          public NamespaceBinding[] getDeclaredNamespaces​(NamespaceBinding[] buffer)

      Get all namespace declarations and undeclarations defined on this element.

      This method is intended primarily for internal use. User applications needing information about the namespace context of a node should use `iterateAxis(Axis.NAMESPACE)`. (However, not all implementations support the namespace axis, whereas all implementations are required to support this method.)

      This implementation of the method is suitable for all nodes other than elements; it returns an empty array.

      Specified by:
        `getDeclaredNamespaces` in interface `NodeInfo`
      Parameters:
        `buffer` - If this is non-null, and the result array fits in this buffer, then the result may overwrite the contents of this array, to avoid the cost of allocating a new array on the heap.
      Returns:
        An array of namespace binding objects representing the namespace declarations and undeclarations present on this element. For a node other than an element, return null. If the uri part is "", then this is a namespace undeclaration rather than a declaration. The XML namespace is never included in the list. If the supplied array is larger than required, then the first unused entry will be set to null.

        For a node other than an element, the method returns null.

    - #### getAllNamespaces

          public NamespaceMap getAllNamespaces()

      Get all the namespace bindings that are in-scope for this element.

      For an element return all the prefix-to-uri bindings that are in scope. This may include a binding to the default namespace (represented by a prefix of ""). It will never include "undeclarations" - that is, the namespace URI will never be empty; the effect of an undeclaration is to remove a binding from the in-scope namespaces, not to add anything.

      For a node other than an element, returns null.

      Specified by:
        `getAllNamespaces` in interface `NodeInfo`
      Returns:
        the in-scope namespaces for an element, or null for any other kind of node.

    - #### getRoot

          public NodeInfo getRoot()

      Get the root node - always a document node with this tree implementation
      Specified by:
        `getRoot` in interface `NodeInfo`
      Returns:
        the NodeInfo representing the containing document

    - #### hasChildNodes

          public boolean hasChildNodes()

      Determine whether the node has any children. This implementation calls iterateAxis, so the subclass implementation of iterateAxis must avoid calling this method.
      Specified by:
        `hasChildNodes` in interface `NodeInfo`
      Returns:
        True if the node has one or more children

    - #### getFingerprint

          public int getFingerprint()

      Get the fingerprint of the node
      Specified by:
        `getFingerprint` in interface `NodeInfo`
      Returns:
        the node's fingerprint, or -1 for an unnamed node
      Throws:
        `java.lang.UnsupportedOperationException` - if this method is called for a node where hasFingerprint() returns false;

    - #### hasFingerprint

          public boolean hasFingerprint()

      Test whether a fingerprint is available for the node name
      Specified by:
        `hasFingerprint` in interface `NodeInfo`
      Returns:
        true if the implementation of this node provides fingerprints.